'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./base/utils');

var _asField = require('./base/asField');

var _parser = require('./base/parser');

var _parser2 = _interopRequireDefault(_parser);

var _resolve = require('./base/resolve');

var _resolve2 = _interopRequireDefault(_resolve);

var _validate = require('./base/validate');

require('../atom.css');

require('../index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function renderField(schema, fields, events) {
  var _parse = (0, _parser2.default)(schema, fields),
      Field = _parse.Field,
      props = _parse.props;

  if (!Field) {
    return null;
  }
  return _react2.default.createElement(Field, _extends({
    isRoot: true
  }, props, {
    value: schema.data
  }, events, {
    formData: schema.formData
  }));
}

// 在顶层将 propsSchema 和 uiSchema 合并，便于后续处理。 也可直接传入合并的 schema
var Wrapper = function Wrapper(_ref) {
  var schema = _ref.schema,
      _ref$propsSchema = _ref.propsSchema,
      propsSchema = _ref$propsSchema === undefined ? {} : _ref$propsSchema,
      _ref$uiSchema = _ref.uiSchema,
      uiSchema = _ref$uiSchema === undefined ? {} : _ref$uiSchema,
      readOnly = _ref.readOnly,
      showValidate = _ref.showValidate,
      rest = _objectWithoutProperties(_ref, ['schema', 'propsSchema', 'uiSchema', 'readOnly', 'showValidate']);

  var _schema = schema ? schema : (0, _utils.combineSchema)(propsSchema, uiSchema);

  return _react2.default.createElement(FormRender, _extends({
    readOnly: readOnly,
    showValidate: !readOnly && showValidate // 预览模式下不展示校验
  }, rest, {
    schema: _schema
  }));
};

var FormRender = (_temp = _class = function (_React$Component) {
  _inherits(FormRender, _React$Component);

  function FormRender() {
    _classCallCheck(this, FormRender);

    var _this = _possibleConstructorReturn(this, (FormRender.__proto__ || Object.getPrototypeOf(FormRender)).call(this));

    _this.needUpdateForm = function () {
      var _this$props = _this.props,
          schema = _this$props.schema,
          formData = _this$props.formData,
          onChange = _this$props.onChange,
          onValidate = _this$props.onValidate;

      var data = (0, _resolve2.default)(schema, formData);
      onChange(data);
      onValidate((0, _validate.getValidateList)(data, schema));
    };

    _this.originWidgets = null;
    _this.generatedFields = {};
    return _this;
  }

  _createClass(FormRender, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.needUpdateForm();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _props = this.props,
          schema = _props.schema,
          formData = _props.formData;
      // 遇到有更新 schema 情况，假如项数增多了，发现增多项不会更新

      if (!(0, _utils.isDeepEqual)(nextProps.schema, schema) || !(0, _utils.isDeepEqual)(Object.keys(nextProps.formData), Object.keys(formData))) {
        setTimeout(this.needUpdateForm, 0);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          name = _props2.name,
          column = _props2.column,
          className = _props2.className,
          schema = _props2.schema,
          formData = _props2.formData,
          widgets = _props2.widgets,
          FieldUI = _props2.FieldUI,
          customized = _props2.fields,
          mapping = _props2.mapping,
          showDescIcon = _props2.showDescIcon,
          showValidate = _props2.showValidate,
          displayType = _props2.displayType,
          _onChange = _props2.onChange,
          onValidate = _props2.onValidate,
          readOnly = _props2.readOnly,
          labelWidth = _props2.labelWidth;


      var generated = {};
      var list = widgets;
      if (!this.originWidgets) {
        this.originWidgets = list;
      }
      Object.keys(list).forEach(function (key) {
        var oWidget = _this2.originWidgets[key];
        var nWidget = list[key];
        var gField = _this2.generatedFields[key];
        if (!gField || oWidget !== nWidget) {
          if (oWidget !== nWidget) {
            _this2.originWidgets[key] = nWidget;
          }
          gField = (0, _asField.asField)({ FieldUI: FieldUI, Widget: nWidget });
          _this2.generatedFields[key] = gField;
        }
        generated[key] = gField;
      });
      return _react2.default.createElement(
        'div',
        { className: className },
        renderField({
          schema: schema,
          data: formData,
          name: name,
          column: column,
          showDescIcon: showDescIcon,
          showValidate: showValidate,
          displayType: displayType,
          readOnly: readOnly,
          labelWidth: labelWidth,
          formData: formData
        }, {
          // 根据 Widget 生成的 Field
          generated: generated,
          // 自定义的 Field
          customized: customized,
          // 字段 type 与 widgetName 的映射关系
          mapping: mapping
        }, {
          onChange: function onChange(key, val) {
            _onChange(val);
            onValidate((0, _validate.getValidateList)(val, schema));
          }
        })
      );
    }
  }]);

  return FormRender;
}(_react2.default.Component), _class.propTypes = {
  name: _propTypes2.default.string,
  column: _propTypes2.default.number,
  schema: _propTypes2.default.object,
  formData: _propTypes2.default.object,
  widgets: _propTypes2.default.objectOf(_propTypes2.default.func),
  FieldUI: _propTypes2.default.elementType,
  fields: _propTypes2.default.objectOf(_propTypes2.default.element),
  mapping: _propTypes2.default.object,
  showDescIcon: _propTypes2.default.bool,
  showValidate: _propTypes2.default.bool,
  displayType: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  onValidate: _propTypes2.default.func,
  readOnly: _propTypes2.default.bool,
  labelWidth: _propTypes2.default.number
}, _class.defaultProps = {
  name: '$form',
  column: 1,
  schema: {},
  formData: {},
  widgets: {},
  FieldUI: _asField.DefaultFieldUI,
  fields: {},
  mapping: {},
  showDescIcon: false,
  showValidate: true,
  displayType: 'column',
  onChange: function onChange() {},
  onValidate: function onValidate() {},
  readOnly: false,
  labelWidth: 120
}, _temp);
exports.default = Wrapper;